<template>
    <div class="row" :class="[isSender ? 'justify-end' : ' justify-start']">
        <div
            class="bubble-document q-pa-sm"
            :class="[isSender ? 'justify-end sender ' : '']"
        >
            <div class="content row justify-start items-center no-wrap">
                <q-icon name="mdi-file-outline" size="30px" />
                <div class="q-ml-sm col single-line">{{ message.text }}</div>
                <q-icon
                    class="btn-action"
                    @click.stop="downloadFile"
                    :color="isSender ? 'white' : 'black'"
                    name="mdi-download-circle-outline"
                    size="30px"
                />
            </div>
            <span class="time-text helvetica-neue-medium font-10 q-pr-xs">
                {{ time }}
            </span>
            <q-btn
                dense
                text
                flat
                v-if="statusIcon.name"
                @click="resendErrorMessage(statusIcon.name, message.id)"
            >
                <q-icon
                    :name="statusIcon.name"
                    :color="statusIcon.color"
                    size="15px"
                />
            </q-btn>
        </div>
    </div>
</template>

<script lang="ts">
import { defineComponent } from 'vue';
import MessageController from '../../../src/controller/MessageController';
import { Message } from 'src/services/models/Message';
import { useStore } from 'src/store';

export default defineComponent({
    name: 'BubbleDocument',
    props: {
        message: {
            type: Object as () => Message,
            required: true
        }
    },
    setup(props) {
        const store = useStore();

        const { isSender, downloadFile, time, statusIcon } = MessageController(
            props.message
        );

        const resendErrorMessage = (statusName: any, id: string) => {
            if (statusName == 'error') {
                store.dispatch('message/resendErrorMessage', id);
            }
        };

        return {
            isSender,
            downloadFile,
            time,
            statusIcon,
            resendErrorMessage
        };
    }
});
</script>
